## deepin-im 1.0.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

project(deepin-im VERSION 1.0 LANGUAGES C CXX)

include(GNUInstallDirs)

set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

set(CMAKE_POSITION_INDEPENDENT_CODE ON)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
option(ENABLE_GTK3_IM_MODULE "Enable GTK3 IM Module" ON)
option(ENABLE_GTK4_IM_MODULE "Enable GTK4 IM Module" ON)

find_package(ECM 1.4.0 REQUIRED)
set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH})

find_package(Qt6 REQUIRED COMPONENTS Core Gui Quick Widgets Xml DBus)
find_package(Qt6Gui ${REQUIRED_QT6_VERSION} REQUIRED Private)
find_package(Fcitx5Qt6DBusAddons REQUIRED)
find_package(PkgConfig REQUIRED)
find_package(WaylandScanner REQUIRED)
find_package(Dtk6Core QUIET)
find_package(Dtk6Gui QUIET)

if (Dtk6Core_FOUND)
  add_definitions(-DDtk6Core_FOUND)
endif()

if (Dtk6Gui_FOUND)
  add_definitions(-DDtk6Gui_FOUND)
endif()

add_definitions(-DWLR_USE_UNSTABLE)

pkg_check_modules(xcb REQUIRED IMPORTED_TARGET xcb)
pkg_check_modules(xcb-xinput REQUIRED IMPORTED_TARGET xcb-xinput)
pkg_check_modules(xcb-aux REQUIRED IMPORTED_TARGET xcb-aux)
pkg_check_modules(xkbcommon REQUIRED IMPORTED_TARGET xkbcommon)
pkg_check_modules(xkeyboard-config REQUIRED IMPORTED_TARGET xkeyboard-config)
pkg_check_modules(wayland-client REQUIRED IMPORTED_TARGET wayland-client)
pkg_check_modules(wayland-server REQUIRED IMPORTED_TARGET wayland-server)
pkg_check_modules(libudev REQUIRED IMPORTED_TARGET libudev)
pkg_check_modules(libinput REQUIRED IMPORTED_TARGET libinput)
pkg_check_modules(gio REQUIRED IMPORTED_TARGET gio-2.0)
pkg_check_modules(wlroots REQUIRED IMPORTED_TARGET wlroots)

pkg_get_variable(WAYLAND_PROTOCOLS_DIR wayland-protocols pkgdatadir)

if (ENABLE_GTK3_IM_MODULE)
    pkg_check_modules(Gtk3 REQUIRED IMPORTED_TARGET "gtk+-3.0")
    pkg_check_modules(Gdk3 REQUIRED IMPORTED_TARGET "gdk-3.0")
    pkg_get_variable(GTK3_BINARY_VERSION "gtk+-3.0" "gtk_binary_version")
    pkg_get_variable(GTK3_TARGETS "gtk+-3.0" "targets")
endif()

if (ENABLE_GTK4_IM_MODULE)
    pkg_check_modules(Gtk4 REQUIRED IMPORTED_TARGET "gtk4>=4.2")
    pkg_get_variable(GTK4_BINARY_VERSION "gtk4" "gtk_binary_version")
    pkg_get_variable(GTK4_TARGETS "gtk4" "targets")
endif()

add_library(wayland_protocols OBJECT)

ecm_add_wayland_server_protocol(wayland_protocols
  PROTOCOL ${WAYLAND_PROTOCOLS_DIR}/stable/xdg-shell/xdg-shell.xml
  BASENAME xdg-shell
)

ecm_add_wayland_server_protocol(wayland_protocols
  PROTOCOL misc/wayland-protocols/input-method-unstable-v1.xml
  BASENAME input-method-unstable-v1
)

ecm_add_wayland_server_protocol(wayland_protocols
  PROTOCOL misc/wayland-protocols/input-method-unstable-v2.xml
  BASENAME input-method-unstable-v2
)

ecm_add_wayland_server_protocol(wayland_protocols
  PROTOCOL misc/wayland-protocols/virtual-keyboard-unstable-v1.xml
  BASENAME virtual-keyboard-unstable-v1
)

ecm_add_wayland_server_protocol(wayland_protocols
  PROTOCOL ${WAYLAND_PROTOCOLS_DIR}/unstable/text-input/text-input-unstable-v3.xml
  BASENAME text-input-unstable-v3
)

ecm_add_wayland_server_protocol(wayland_protocols
  PROTOCOL misc/wayland-protocols/wlr-foreign-toplevel-management-unstable-v1.xml
  BASENAME wlr-foreign-toplevel-management-unstable-v1
)

ecm_add_wayland_server_protocol(wayland_protocols
  PROTOCOL misc/wayland-protocols/treeland-foreign-toplevel-manager-v1.xml
  BASENAME treeland-foreign-toplevel-manager-server-protocol-v1
)

include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_subdirectory(src)
add_subdirectory(misc)
add_subdirectory(demo)

=== demo/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: GPL-3.0-or-later

add_subdirectory(qttestdemo)
add_subdirectory(gtktestdemo)

=== misc/CMakeLists.txt ===
# SPDX-FileCopyrightText: None
#
# SPDX-License-Identifier: CC0-1.0

add_subdirectory(im-config)
add_subdirectory(systemd)
add_subdirectory(dsg)

=== src/CMakeLists.txt ===
include_directories(.)

set(DIM_DATA_DIR ${CMAKE_INSTALL_DATAROOTDIR}/deepin-im)
set(DIM_ADDON_INFO_DIR ${DIM_DATA_DIR}/addon)
set(DIM_ADDON_DIR ${CMAKE_INSTALL_LIBDIR}/deepin-im)

add_subdirectory(common)
add_subdirectory(wl)
add_subdirectory(dimwl)
add_subdirectory(dimcore)
add_subdirectory(dim)
add_subdirectory(addons)
add_subdirectory(kimpanel)
add_subdirectory(qtimmodule)
add_subdirectory(gtkimmodule)
add_subdirectory(wladdonsbase)

=== demo/gtktestdemo/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: GPL-3.0-or-later

set(GTK_TEST_DEMO_SOURCES
  main.cpp
)

add_executable(gtk_im_demo
  ${GTK_TEST_DEMO_SOURCES}
)

target_link_libraries(gtk_im_demo
  PkgConfig::Gtk4
)

install(TARGETS gtk_im_demo
    BUNDLE DESTINATION .
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

=== demo/qttestdemo/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 UnionTech Software Technology Co., Ltd.
#
# SPDX-License-Identifier: GPL-3.0-or-later

set(QT_TEST_DEMO_SOURCES
  main.cpp
  qml.qrc
)

add_executable(qt_im_window
  ${QT_TEST_DEMO_SOURCES}
)

target_link_libraries(qt_im_window PRIVATE
  Qt6::Core
  Qt6::Quick
  Qt6::DBus
)

install(TARGETS qt_im_window
    BUNDLE DESTINATION .
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

=== misc/dsg/CMakeLists.txt ===
set(DCONFIG_FILES
    org.deepin.dde.dim.json
)

install(FILES ${DCONFIG_FILES} DESTINATION ${CMAKE_INSTALL_DATADIR}/dsg/configs/org.deepin.dde.dim)

=== misc/im-config/CMakeLists.txt ===
set(INSTALL_DESTINATION ${CMAKE_INSTALL_DATADIR}/im-config/data)
set(DCONFIG_FILES
    20_dim.conf
    20_dim.rc
)

install(FILES ${DCONFIG_FILES} DESTINATION ${INSTALL_DESTINATION})

=== misc/systemd/CMakeLists.txt ===
if (NOT DEFINED SYSTEMD_USER_UNIT_DIR)
    pkg_get_variable(SYSTEMD_USER_UNIT_DIR systemd systemduserunitdir)
endif()

set(SERVICES
    org.deepin.dde.dim.target
    org.deepin.dde.dimwl@x11.service
    org.deepin.dde.dim@wayland.service
    org.deepin.dde.dim@x11.service
)

install(FILES ${SERVICES} DESTINATION ${SYSTEMD_USER_UNIT_DIR})

=== src/addons/CMakeLists.txt ===
add_subdirectory(waylandserver)
add_subdirectory(wlfrontend)
add_subdirectory(keyboard)
add_subdirectory(fcitx5)
add_subdirectory(ibus)
add_subdirectory(trayicon)

=== src/common/CMakeLists.txt ===
add_library(shm_open_anon OBJECT
    shm_open_anon.h
    shm_open_anon.c
)

=== src/dim/CMakeLists.txt ===
set(DIM_SOURCES
  main.cpp
  ./dbus/DimDBusType.cpp
  ./dbus/DimDBusAdaptor.cpp
)

set(DIM_HEADERS
  ./dbus/DimDBusType.h
  ./dbus/DimDBusAdaptor.h
)

qt_add_dbus_adaptor(DIM_SOURCES ${CMAKE_SOURCE_DIR}/misc/adaptor/org.deepin.dde.Dim.xml dbus/DimDBusAdaptor.h DimDBusAdaptor)

add_executable(dim
  ${DIM_SOURCES}
  ${DIM_HEADERS}
)

target_link_libraries(dim PRIVATE
  dimcore
  Qt6::Gui
  Qt6::DBus
  $<$<BOOL:${Dtk6Core_FOUND}>:Dtk6::Core>
)

install(TARGETS dim
  BUNDLE DESTINATION .
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

=== debian/changelog ===
deepin-im (1.0.3) unstable; urgency=medium

  * fix: treeland foreign toplevel manager protocols mismatch with dim

 -- dengbo <dengbo@deepin.org>  Thu, 25 Jan 2024 10:26:57 +0800

deepin-im (1.0.2) unstable; urgency=medium

  * feat(wayland): 支持同时使用多输入法
  * chore(im-config): use fcitx5 in x11
  * feat: ibus use wayland protocol communication

 -- dengbo <dengbo@deepin.org>  Fri, 12 Jan 2023 13:44:50 +0800

deepin-im (1.0.1) unstable; urgency=medium

  * release deepin input method 1.0.1.

 -- dengbo <dengbo@deepin.org>  Mon, 18 Dec 2023 11:36:05 +0800

deepin-im (1.0.0) unstable; urgency=medium

  * Initial release.

 -- dengbo <dengbo@deepin.org>  Thu, 17 Aug 2023 09:31:07 +0800

=== debian/control ===
Source: deepin-im
Section: utils
Priority: optional
Maintainer: Deepin Packages Builder <packages@deepin.com>
Rules-Requires-Root: no
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 extra-cmake-modules,
 libdtk6core-dev,
 libdtk6gui-dev,
 libfcitx5-qt6-dev,
 libglib2.0-dev,
 libgtk-3-dev,
 libgtk-4-dev,
 libudev-dev,
 libwayland-dev,
 libwlroots-dev,
 libxcb-util-dev,
 libxcb-xinput-dev,
 libxcb1-dev,
 libxkbcommon-dev,
 pkg-config,
 qt6-base-dev,
 qt6-base-private-dev,
 qt6-declarative-dev,
 qt6-wayland-dev,
 qtbase5-private-dev,
 xkb-data,
Standards-Version: 4.6.2
Homepage: https://www.deepin.org

Package: deepin-im
Architecture: any
Multi-Arch: foreign
Depends:
 qml6-module-qt-labs-platform,
 qml6-module-qtqml-workerscript,
 qml6-module-qtquick,
 qml6-module-qtquick-window,
 ${misc:Depends},
 ${shlibs:Depends},
Description: deepin input method
 deepin input method is input method in deepin desktop environment,
 it can support ibus and fcitx input method framework.
